/**
 **  Prototypes for egslayers.library
 **
 **  Created: 14. July 1992   mvk
 **  Changed: 14. July 1992
 **           24. July 1992   us
 **           10. Jan  1992   jsm
 **
 **/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EXEC_PORTS_H
#include        <exec/ports.h>
#endif
#ifndef         EXEC_LISTS_H
#include        <exec/lists.h>
#endif
#ifndef         EXEC_SEMAPHORES_H
#include        <exec/semaphores.h>
#endif
#ifndef         EGS_EGS_H
#include        <egs/egs.h>
#endif
#ifndef         EGS_EGSBLIT_H
#include        <egs/egsblit.h>
#endif
#ifndef         EGS_EGSLAYERS_H
#include        <egs/egslayers.h>
#endif

void EL_FreeRect (EB_ClipRectPtr rect);
void EL_FreeRegion (EB_ClipRectPtr old);
EB_ClipRectPtr EL_NewRect (void);
EB_ClipRectPtr EL_DupRegion (EB_ClipRectPtr old);
EB_ClipRectPtr EL_DupMoveRegion (EB_ClipRectPtr list, WORD dx, WORD dy);
EB_ClipRectPtr EL_MoveRegion (EB_ClipRectPtr list, WORD dx, WORD dy);

EB_ClipRectPtr EL_OrRectRegion (EB_ClipRectPtr oldList,
                                EB_ClipRectPtr new);

EB_ClipRectPtr EL_OrRegionRegion (EB_ClipRectPtr oldList,
                                  EB_ClipRectPtr newList);

EB_ClipRectPtr EL_DelRectRegion (EB_ClipRectPtr oldList,
                                 EB_ClipRectPtr new);

EB_ClipRectPtr EL_DelRegionRegion (EB_ClipRectPtr oldList,
                                   EB_ClipRectPtr newList);

EB_ClipRectPtr EL_AndRectRegion (EB_ClipRectPtr oldList,
                                 EB_ClipRectPtr new);

EB_ClipRectPtr EL_AndRegionRegion (EB_ClipRectPtr oldList,
                                   EB_ClipRectPtr newList);

EL_LayerInfoPtr EL_CreateLayerInfo (E_EBitMapPtr map,
                                    struct MsgPort *port, WORD width,
                                    WORD height, LONG color,
                                    E_EBitMapPtr pattern);

void EL_FreeLayerInfo (EL_LayerInfoPtr info);
void EL_LockLayer (EL_LayerPtr layer);
void EL_UnlockLayer (EL_LayerPtr layer);
void EL_LockLayerInfo (EL_LayerInfoPtr info);
void EL_UnlockLayerInfo (EL_LayerInfoPtr info);
void EL_LockLayers (EL_LayerInfoPtr info);
void EL_UnlockLayers (EL_LayerInfoPtr info);
EL_LayerPtr EL_CreateUpfrontLayer (EL_LayerInfoPtr info,
                                   WORD x, WORD y,
                                   WORD width, WORD height,
                                   WORD maxWidth, WORD maxHeight,
                                   ULONG flags, LONG color);

EL_LayerPtr EL_CreateBehindLayer (EL_LayerInfoPtr info,
                                  WORD x, WORD y,
                                  WORD width, WORD height,
                                  WORD maxWidth, WORD maxHeight,
                                  ULONG flags, LONG color);

void EL_DeleteLayer (EL_LayerPtr layer);
void EL_LayerToFront (EL_LayerPtr layer);
void EL_LayerToBack (EL_LayerPtr layer);
void EL_MoveLayerBehind (EL_LayerPtr layer, EL_LayerPtr behind);
void EL_MoveLayerInFront (EL_LayerPtr layer, EL_LayerPtr front);
void EL_MoveLayer (EL_LayerPtr layer, WORD dx, WORD dy);
void EL_SizeLayer (EL_LayerPtr layer, WORD dx, WORD dy);
void EL_ScrollLayer (EL_LayerPtr layer, WORD dx, WORD dy);
EL_LayerPtr EL_WhichLayer (EL_LayerInfoPtr info, WORD x, WORD y);
ULONG EL_BeginUpdate (EL_LayerPtr layer, LONG key);
void EL_EndUpdate (EL_LayerPtr layer, ULONG done);
void EL_UpdateBackMap (EL_LayerPtr layer);
void EL_UpdateFrontMap (EL_LayerPtr layer);
EL_SmartPtr EL_AndSmartClip (EL_SmartPtr smart, EB_ClipRectPtr clip);
void EL_FreeSmartList (EL_SmartPtr smart);
void EL_Invalidate (EL_LayerPtr layer, EB_ClipRectPtr region);
void EL_InstallLHook (EL_LayerPtr layer, EL_BackHookPtr hook);
void EL_InstallLIHook (EL_LayerInfoPtr info, EL_BackHookPtr hook);
void EL_RemoveRefreshRegion (EL_LayerPtr layer, EB_ClipRectPtr region);
