#ifndef EGS_EGSREQUEST_H
#define EGS_EGSREQUEST_H

/***************************************************************************\
*
*  $
*  $ FILE     : egsrequest.h
*  $ VERSION  : 1
*  $ REVISION : 3
*  $ DATE     : 07-Feb-93 20:53
*  $
*  $ Author   : mvk
*  $
*
*****************************************************************************
*                                                                           *
* (c) Copyright 1990/93 VIONA Development                                   *
*     All Rights Reserved                                                   *
*                                                                           *
\***************************************************************************/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EGS_EGSINTUI_H
#include        <egs/egsintui.h>
#endif
#ifndef         EGS_EGSGADBOX_H
#include        <egs/egsgadbox.h>
#endif
#ifndef         EGS_EGB_GBSCROLLBOX_H
#include        <egs/egb/gbscrollbox.h>
#endif

#define ER_USER_GADID_MIN  0x100000
#define ER_USER_GADID_MAX  0x1FFFFF

#define ER_REQ_OK         0
#define ER_REQ_FINISHED   1
#define ER_NO_REQWINDOW   2
#define ER_REQ_CANCELED   3

#define ER_AUTO_CLOSE     0x0000001


typedef struct ER_ReqContext *ER_ReqContextPtr;
typedef struct ER_Request *ER_RequestPtr;

struct ER_ReqContext{
	  ER_RequestPtr        First,Last;
};


struct ER_Request{
	 APTR                 ObjectKey;
	 LONG                 Type;
	 ER_ReqContextPtr     Context;
	 ER_RequestPtr        Next,Prev;
	 UBYTE                Error;
	 UBYTE                Pad0;
	 UWORD                Pad1;
	 APTR                 UserData;
	 ULONG                Private1[6];
	 APTR                 Private2;
	 struct EI_NewWindow *Nw;
	 EB_GadContext        Con;
	 EB_GadBoxPtr         Root;
	 EI_MenuPtr           Menu;
	 char                *Title;
	 struct MsgPort      *Port;
	 EI_ScreenPtr         Screen;
	 EI_WindowPtr         RWindow;
	 ULONG                Flags;
	 APTR                 Private3[8];
};

struct ER_TextList{
	 struct List          List;
	 UWORD                Pad;
	 APTR                 Con;
};

typedef struct ER_FileRequest *ER_FileRequestPtr;

struct ER_FileRequest {
	 struct ER_Request    Req;
	 UWORD                NameLen;
	 char                 Name[32];
	 UWORD                Pad1;
	 UWORD                PathLen;
	 char                 Path[100];
	 UWORD                Pad2;
	 UWORD                PattLen;
	 char                 Pattern[100];
	 UWORD                Pad3;
	 struct EB_InfoBox    Fnumbox,Dnumbox;
	 struct ER_TextList   Files,Volumes;
	 EGB_ScrollGadPtr     FileGad,VolGad;
	 EI_StringGadPtr      PathGad,NameGad,PattGad;
	 UWORD                OnameLen;
	 char                 Oname[32];
	 UWORD                Pad4;
	 UWORD                OPathLen;
	 char                 OPath[100];
	 UWORD                Pad5;
	 UWORD                OPattLen;
	 char                 OPattern[100];
	 UWORD                Pad7;
	 struct Node         *OldFile;
	 UBYTE                CursLeft;
	 UBYTE                Pad8;
	 UWORD                Pad9;
	 struct Node         *LeftCurs,*RightCurs;
};

typedef struct ER_SimpleRequest *ER_SimpleRequestPtr;

struct ER_SimpleRequest {

	 struct ER_Request    Req;
	 APTR                 Texts;
	 APTR                 Selects;
	 WORD                 Selected;
	 WORD                 Pad0;
};

#endif  /* EGS_EGSREQUEST_H */

