/*
** Autor: Markus van Kempen
** Date : 18. Dezember 1992
**
** Global variables & structures
**
**
** See myopen.c
**
**/

#include "includes.c"
#include "protos.h"
/*
**    DEFINE's
**
*/

/**** Define's for window *****/

/*
**   Window system gadgets
**
*/

#define myWinGtmp (EI_WINDOWDRAG  | EI_WINDOWSIZE )
#define myWinGads (EI_WINDOWCLOSE | EI_WINDOWBACK | myWinGtmp )

/*
EI_WINDOWDRAG |
EI_WINDOWCLOSE |
EI_WINDOWSIZE |
EI_WINDOWFRONT |
EI_WINDOWBACK,
EI_WINDOWFLIP
EI_WINDOWBIG
EI_WINDOWSMALL
EI_WINDOWICON
EI_WINDOWARROWL
EI_WINDOWARROWR
EI_WINDOWARROWU
EI_WINDOWARROWD
EI_WINDOWSCROLLH
EI_WINDOWSCROLLV
EI_WINDOWDRAG
*/

/*
** Flags for window
*/
#define mywf1       (EI_FRONTBACKGADGET | EI_WINDOWCENTER)
#define mywf2       (EI_SIZEBBOTTOM | EI_GIMMEZEROZERO | mywf1)
#define myWinFlags  (EI_WINDOWACTIVE | EI_WINDOW_MENULOCAL | mywf2)


/* Corresponding EI_WindowFlagSet has 32 bits ! */

/*

EI_WINDOWACTIVE     |
EI_WINDOW_MENULOCAL |
EI_FRONTBACKGADGET  |
EI_WINDOWCENTER     |
EI_SIMPLE_REFRESH   |
EI_GIMMEZEROZERO    |
EI_SIZEBRIGHT       ,

EI_GIMMEZEROZERO
EI_BORDERLESS
EI_SUPER_BITMAP
EI_SIMPLE_REFRESH
EI_WINDOWREFRESH
EI_WINDOWACTIVE
EI_WINDOW_MENULOCAL
EI_OWN_IDCMPPORT
EI_OWN_COLORPALETTE
EI_FRONTBACKGADGET
EI_RMBTRAP
EI_REPROTMOUSE
EI_BACKDROP
EI_SMART_REFRESH
EI_WINDOW_MENUPOPUP
EI_SIZEBBOTTOM
EI_SIZEBRIGHT
EI_WINDOW_USERSTYLE
EI_ACTIVETOFRONT
EI_QUICKSCROLL
EI_WINDOW_SLEEPING
EI_FIXWINDOW_RATIO
EI_FORCE_TO_SCREEN
EI_WINDOWCENTER
EI_SENDOUT_SIDEMOVES
*/

/*
**
**   EIDCMP-FLAGS
*/

#define myif          (EI_iGADGETUP | EI_iMENUPICK | EI_iSIZEVERIFY)
#define myEdcmpFlags  (EI_iCLOSEWINDOW | EI_iNEWSIZE | myif)

/*
   Corresponding EI_EIDCMPFlagSet has 32 bits !
   IDCMP -Flags
*/

/*
EI_iCLOSEWINDOW |
EI_iMOVEWINDOW  |
EI_iSIZEVERIFY  |
EI_iNEWSIZE     |
EI_iMENUPICK,
EI_iMOUSEBOTTONS
EI_iMOUSEMOVE
EI_iRAWKEY
EI_iACTIVEWINDOW
EI_iREFRESHWINDOW
EI_iCLOSEWINDOW
EI_iNEWSIZE
EI_iGADGETDOWN
EI_iGADGETUP
EI_iMENUVERIFY
EI_iVANILLAKEY
EI_iSIZEVERIFY
EI_iINACTIVEWINDOW
EI_iINTUITICKS
EI_iDISKINSERT
EI_iDISKREMOVE
EI_iNEWPREFS
*/

/*
**
**  Global variables
**
*/

int                 dummy;
EI_MenuPtr          Menu        =NULL;
EG_EFontPtr         FontforMenu =NULL;
EG_EFontPtr         FontforGad  =NULL;
EG_EFontPtr         FontforScr  =NULL;
struct EI_Window    *Window     =NULL;
ER_SimpleRequestPtr ErrorReq    =NULL;
EB_GadContext       con         =NULL;

/*
**  myopen()
*/

struct OpenStructTyp
{
        ULONG *Base;
        char  *Name;
        ULONG Version;
};

/*
 * The EGS lib bases
 *
 */

struct Library *EGSBase;
struct Library *EGSBlitBase;
struct Library *EGSLayersBase;
struct Library *EGSGfxBase;
struct Library *EGSIntuiBase;
struct Library *EGBBase;
struct Library *EGSRequestBase;
struct Library *EGBMenuSelectBase;
struct Library *EGBRadioBase;
struct Library *EGBScrollBase;
struct Library *EGBSelectBase;
struct Library *EGBSetBase;
struct Library *EGBTextInfoBase;

/********************************************/

struct OpenStructTyp OpenStruct[] =
{
  { (ULONG*) &EGSBase          , "egs.library",0               },
  { (ULONG*) &EGSBlitBase      , "egsblit.library",0           },
  { (ULONG*) &EGSLayersBase    , "egslayers.library",0         },
  { (ULONG*) &EGSGfxBase       , "egsgfx.library",0            },
  { (ULONG*) &EGSIntuiBase     , "egsintui.library",0          },
  { (ULONG*) &EGBBase          , "egsgadbox.library",0         },
  { (ULONG*) &EGSRequestBase   , "egsrequest.library",0         },
  { (ULONG*) &EGBMenuSelectBase, "egb/gbmenuselect.library",0  },
  { (ULONG*) &EGBRadioBase     , "egb/gbradio.library",0       },
  { (ULONG*) &EGBScrollBase    , "egb/gbscrollbox.library",0   },
  { (ULONG*) &EGBSelectBase    , "egb/gbselect.library",0      },
  { (ULONG*) &EGBSetBase       , "egb/gbsets.library",0        },
  { (ULONG*) &EGBTextInfoBase  , "egb/gbtextinfo.library",0    },
  { 0L,0L,0L }
};





