/*
*
*  $
*  $ FILE     : colorpot.c
*  $ VERSION  : 1
*  $ REVISION : 30
*  $ DATE     : 08-Dec-93 13:19
*  $
*  $ Author   : mvk
*  $
*
**
**
**
** This is a demo program about EGS Gadget gbcolorpot library.
**
** How works gbcolorpot ?
**
**
** With this program
** you get a colorpot gadget in the left top edge. In this gadget you
** can drop color messages. For example there is a global ColorMixer
** (see EGS-Palette in the same directory) and you want to use the mixed
** color in you program. With the colorpot gadget is it possible. Click in the
** colorpot gadget form the mixer, drag the color to your own colorpot gadget and
** let it drop. After this you get the message EI_iGADGETUP, so that you
** can read the color information from the colorpot gadget (see eventloop
** case MY_COLOR).
**
**
**
**  (c) by VIONA-Development 92/93
**
*/

#include "Includes.c"

struct GadDataStruct
{
      WORD  prop_Value_R;                 // HorizProp
      WORD  prop_Value_G;                 // HorizProp
      WORD  prop_Value_B;                 // HorizProp
      BYTE  txtb_Flag;                    // TextBool
};

struct GadDataStruct GadData;

#include "Global.h"
#include "Open_Close.c"
#include "Eventloop.c"

/**/


APTR My_FindGadget(EB_GadContext GadCon,WORD ID)
{
	/*
	** MasterGadPtr because the window is create with
	** EB_CreateMasterWindow function
	*/
	return( EB_FindGadget(
		((MasterGadPtr)GadCon->First)->FirstSon,
		((MasterGadPtr)GadCon->First)->NumSons,ID));
}


/*
**
** This function gets the data form all gadgets
** and puts it in a structure
**
*/
void GetGadgetData(EB_GadContext GadCon)
{
	APTR          gadget;

      // MY_PROP:

      gadget = My_FindGadget(GadCon,MY_PROP_R);

      if( gadget != NULL )
      {
	  GadData.prop_Value_R=((EB_SPropGadPtr)gadget)->RealProp->Value;
      }

}


/*
**
** This function put the data in form the GadData structure
** into the gadget structure form the Context
**
*/
void PutGadgetData(EB_GadContext GadCon)
{
	EI_GadgetPtr  gadget;

	// MY_PROP:

	gadget = My_FindGadget(GadCon,MY_PROP_R);

	if( gadget != NULL )
	{
	    ((EB_SPropGadPtr)gadget)->RealProp->Value=GadData.prop_Value_R;
	}
}



/*
**
** This function creates the Gadgets using the egsgadbox.library
**
*/

EI_WindowPtr My_CreateGads(EI_WindowPtr Window)
{
     EB_GadBoxPtr   vbox,root;
     EB_GadBoxPtr   hbox;

      if( (GadCon=EB_CreateGadContext(NULL,NULL,-1,-1)) == NULL)
	  myCleanExit(ERR_NOMEM);

	root   = EB_CreateVertiBox(GadCon);
	vbox   = EB_CreateVertiBox(GadCon);
	hbox   = EB_CreateHorizBox(GadCon);

	EB_AddLastSon(hbox,
		  EGB_CreateColorPotGadget(GadCon,MY_COLOR,0,0,0));

	EB_AddLastSon(hbox, EB_CreateHorizFill( GadCon, EB_FILL_RIGHT, -1));

	EB_AddLastSon(vbox,hbox);

	EB_AddLastSon(vbox, EB_CreateVertiFill( GadCon, EB_FILL_ALL, -1));

	EB_AddLastSon(vbox, EB_CreateSuperHorizProp(GadCon,256,1,1,MY_PROP_R,
			    EB_INC_BOTTOM_RIGHT|EB_DEC_BOTTOM_RIGHT));

	EB_AddLastSon(vbox, EB_CreateVertiFill( GadCon, EB_FILL_ALL, 0));

	EB_AddLastSon(vbox, EB_CreateSuperHorizProp(GadCon,256,1,1,MY_PROP_G,
			    EB_INC_BOTTOM_RIGHT|EB_DEC_BOTTOM_RIGHT));

	EB_AddLastSon(vbox, EB_CreateVertiFill( GadCon, EB_FILL_ALL, 0));

	EB_AddLastSon(vbox, EB_CreateSuperHorizProp(GadCon,256,1,1,MY_PROP_B,
			    EB_INC_BOTTOM_RIGHT|EB_DEC_BOTTOM_RIGHT));

	EB_AddLastSon(vbox, EB_CreateVertiFill( GadCon, EB_FILL_ALL, 0));

	EB_NewMinHeight(vbox,100);
	EB_NewMinWidth (vbox,320);

	root = EB_CreateGroupBorder(GadCon,vbox,EB_FILL_ALL,"Hello");

	root = EB_CreateMasterWindow(GadCon,Window,root);

	if( EB_ProcessGadBoxes(GadCon,root) )
	{
	  /*
	  **  Filling in the EI_NewWindow structure
	  */

	  if( Window == NULL )
	    {
						  /* Add more flags to the window */
	      GadCon->NewWin->Title = "Titel";

	      GadCon->NewWin->IDCMPFlags          = EI_iCLOSEWINDOW  |
						    EI_iMOUSEMOVE    |
						    EI_iNEWSIZE      |
						    EI_iSIZEVERIFY   |
						    EI_iMOUSEBUTTONS |
						    EI_iDROP         |
						    EI_iGADGETUP;

	      GadCon->NewWin->Bordef.SysGadgets  |= ( EI_WINDOWCLOSE | EI_WINDOWSIZE );

	      GadCon->NewWin->Flags |= (EI_SIZEBBOTTOM | EI_GIMMEZEROZERO);

	      Window = EI_OpenWindow( GadCon->NewWin );

	    }else{ PutGadgetData( GadCon ); }

	  return(Window);
	}
    return(NULL);
}

int main(int argc, char *argv[])
{
      if ( InitLibraries(OpenStruct) == FALSE )
	  myCleanExit( ERR_LIBS );

	  Window=My_CreateGads(Window);

	   if( Window )
	    {
		 HandleEvents( Window );

	     }else{ myCleanExit( ERR_WINDOW );}

      myCleanExit( NULL ) ;
}



