/*
*  $
*  $ FILE     : eventloop.c
*  $ VERSION  : 1
*  $ REVISION : 8
*  $ DATE     : 08-Dec-93 13:19
*  $
*  $ Author   : mvk
*  $
*
*  This is a ordinary event handler routine like Commodore
*  events handler stuff. The different between Commodores handler
*  and this handler are the IDCMP-Flags and some functions with
*  EI_ or EB_ ..  in front of function names.
*
*
**
**  (c) by VIONA-Development 1992/93
**
*/


BOOL HandleEvents(EI_WindowPtr win)
{
 BOOL             done = FALSE;         /* TRUE, if ready */
 ULONG            GetBits,WaitBits;     /* MessagePort-Bits */
 EI_EIntuiMsgPtr  imess;                /* Message struct pointer */

 WaitBits = (1L << win->UserPort->mp_SigBit) | SIGBREAKF_CTRL_C;

 while (!done)
 {
  GetBits = Wait(WaitBits);

  if (GetBits & SIGBREAKF_CTRL_C) /* CTRL-C */
  {
	done = TRUE;
  }

  while ((imess = (struct EI_EIntuiMsg *)GetMsg(win->UserPort)) != NULL)
  {
     EI_GadgetPtr          gadget,gadget_col;

     gadget=(EI_GadgetPtr)imess->IAddress;

	switch (imess->Class)
	{

	  case EI_iCLOSEWINDOW:
		    printf("iClose\n");
		    done = TRUE;
		    break;


	  case EI_iSIZEVERIFY:

		    printf("VerifySizing ! \n");
		    EI_LockIntuition ();

	     //       GetGadgetData( GadCon );
		    EI_RemoveGList(win,GadCon->First,GadCon->Num);
		    EB_DeleteGadContext(GadCon);

		    EI_UnlockIntuition ();

		    GadCon=NULL;

		    break;

	  case EI_iNEWSIZE:

		    printf("Sizing ! \n");

		    EI_LockIntuition ();

		    win = My_CreateGads( win );
		    if(win)
		    {
		       EI_AddGList( win, GadCon->First, GadCon->Num);
		    }else{ done=TRUE; }

		    EI_UnlockIntuition ();

		    break;

	  case  EI_iGADGETUP:
		    {
		    int       id;

		    printf("Gadget \n");

		    id=gadget->GadgetID;

		    gadget_col=My_FindGadget(GadCon,MY_COLOR);

		      switch(id)
		      {

		      case MY_COLOR:

			     GadData.prop_Value_R=
				    ((EGB_ColorPotGadPtr)gadget)->Color.Red;
			     GadData.prop_Value_G=
				    ((EGB_ColorPotGadPtr)gadget)->Color.Green;
			     GadData.prop_Value_B=
				    ((EGB_ColorPotGadPtr)gadget)->Color.Blue;

			     gadget=My_FindGadget(GadCon,MY_PROP_R);

			     ((EB_SPropGadPtr)gadget)->RealProp->Value=
			     GadData.prop_Value_R;

			     gadget=My_FindGadget(GadCon,MY_PROP_G);

			     ((EB_SPropGadPtr)gadget)->RealProp->Value=
			     GadData.prop_Value_G;

			     gadget=My_FindGadget(GadCon,MY_PROP_B);

			     ((EB_SPropGadPtr)gadget)->RealProp->Value=
			     GadData.prop_Value_B;

			     EI_RefreshGList(win,
			     ((EI_MasterGadPtr)GadCon->First)->FirstSon,3);

			    break;

		      case MY_PROP_R:
			     GadData.prop_Value_R=((EB_SPropGadPtr)gadget)->RealProp->Value;

			     EGB_ModifyColorPotGadget(win,gadget_col,
				  GadData.prop_Value_R,
				  GadData.prop_Value_G,
				  GadData.prop_Value_B);

			     break;

		      case MY_PROP_G:
			     GadData.prop_Value_G=((EB_SPropGadPtr)gadget)->RealProp->Value;

			     EGB_ModifyColorPotGadget(win,gadget_col,
				  GadData.prop_Value_R,
				  GadData.prop_Value_G,
				  GadData.prop_Value_B);

			     break;

		      case MY_PROP_B:
			     GadData.prop_Value_B=((EB_SPropGadPtr)gadget)->RealProp->Value;

			     EGB_ModifyColorPotGadget(win,gadget_col,
				  GadData.prop_Value_R,
				  GadData.prop_Value_G,
				  GadData.prop_Value_B);

			     break;
		      }

		    }
		    break;

	}
   ReplyMsg((struct Message *)imess);
  }
 }
 return done;
}

