/*
*  $
*  $ FILE     : Eventloop.c
*  $ VERSION  : 1
*  $ REVISION : 5
*  $ DATE     : 08-Dec-93 13:15
*  $
*  $ Author   : mvk
*  $
*
*  This is a ordinary event handler routine like Commodore
*  events handler stuff. The different between Commodores handler
*  and this handler are the IDCMP-Flags and some functions with
*  EI_ or EB_ ..  in front of function names.
*
*
**
**  (c) by VIONA-Development 1992/93
**
*/


BOOL HandleEvents(EI_WindowPtr win)
{
 BOOL             done = FALSE;         /* TRUE, if ready */
 ULONG            GetBits,WaitBits;     /* MessagePort-Bits */
 EI_EIntuiMsgPtr  imess;                /* Message struct pointer */

 WaitBits = (1L << win->UserPort->mp_SigBit) | SIGBREAKF_CTRL_C;

 while (!done)
 {
  GetBits = Wait(WaitBits);

  if (GetBits & SIGBREAKF_CTRL_C) /* CTRL-C */
  {
	done = TRUE;
  }

  while ((imess = (struct EI_EIntuiMsg *)GetMsg(win->UserPort)) != NULL)
  {
     EI_GadgetPtr          gadget;

     gadget=(EI_GadgetPtr)imess->IAddress;

	switch (imess->Class)
	{

	  case EI_iCLOSEWINDOW:
		    printf("iClose\n");
		    ReplyMsg ((struct Message *)imess);
		    done = TRUE;
		    break;

/****************************************************************/
	  case EI_iSIZEVERIFY:

		    printf("VerifySizing ! \n");
		    /*
		    *  Is needed for sizing
		    */
		    EI_LockIntuition ();

		    EI_RemoveGList(win,GadCon->First,GadCon->Num);
		    EB_DeleteGadContext(GadCon);

		    EI_UnlockIntuition ();

		    GadCon=NULL;

		    ReplyMsg ( (struct Message *)imess );
		    break;

	  case EI_iNEWSIZE:

		    printf("Sizing ! \n");

		    EI_LockIntuition ();
			  //
		    win = My_CreateGads( win );
		    if( win )
		    {    // Add new claculate gadgets to the window
			 EI_AddGList ( win, GadCon->First,GadCon->Num);

		    }else{ done = TRUE; }

		    EI_UnlockIntuition ();

		    ReplyMsg((struct Message *)imess);
		    break;

/****************************************************************/
	  case  EI_iMOUSEBUTTONS:
		    printf("MouseButtons\n");
		    ReplyMsg((struct Message *)imess);
		    break;

	  case  EI_iGADGETUP:
		    {
		    int       id;
		    char      string[20];

		    printf("Gadget \n");

		    id=gadget->GadgetID;

		      switch(id)
		      {

		      case MY_STR:
			     printf("String Gadget \n");
			     EB_GetStringData((EI_GadgetPtr)gadget,(char *)&string);
			     printf("String = %s \n",string);
			     break;

		      case MY_INT:
			     printf("Integer Gadget \n");
			     printf("Value = %d \n",
				   ((EI_IntGadPtr)gadget)->Value);
			     break;

		      case MY_BUTTON:
		      case MY_BUTTON+1:
		      case MY_BUTTON+2:
			     printf("Button Gadget %d \n",id);
			     printf("Flag = %d \n",((EI_BoolGadPtr)gadget)->Flag);
			     break;

		      case MY_CHECK:
		      case MY_CHECK+1:
		      case MY_CHECK+2:
			     printf("Check Gadget %d\n",id);
			     printf("Flag = %d \n",((EI_BoolGadPtr)gadget)->Flag);
			     break;

		      case MY_ACTION:
		      case MY_ACTION+1:
		      case MY_ACTION+2:
			     printf("Action Gadget %d \n",id);
			     break;


		      case MY_PROP:
			     printf("Prop Gadget 1 \n");
			     printf("Value = %d \n",((EB_SPropGadPtr)gadget)->RealProp->Value);
			     break;

		      case MY_TEXTBOOL:
			     printf("TextBool Gadget 1 \n");
			     printf("Flag  = %d \n",((EI_BoolGadPtr)gadget)->Flag);
			     break;


		      case MY_2DPROP:

			     printf("2 DimProp Gadget 1 \n");
			     printf(" HValue = %d \n",
					      ((EGB_TwoDimPropGadPtr)gadget)->HValue);
			     printf(" VValue = %d \n",
					      ((EGB_TwoDimPropGadPtr)gadget)->VValue);
			     break;
		      }

		    ReplyMsg((struct Message *)imess);
		    }
		    break;
	 default:

	      printf (" Unknown message %x & %x\n ",imess->Class,imess->Code);
	      ReplyMsg((struct Message *)imess);
	}
  }
 }
 return done;
}

