/*
*  $
*  $ FILE     : Programmieren:C-work/EGS-Beispiele/global.h
*  $ VERSION  : 1
*  $ REVISION : 1
*  $ DATE     : 16-Mar-93 16:59
*  $
*  $ Author   : mvk
*  $
*
* (c) by VIONA-Development 1992/93
*
*/

/*
**
**  my protos
**
*/

BOOL InitLibraries(struct OpenStructType *);
void CloseLibraries(struct OpenStructType *);
void myCleanExit(ULONG ERR);
EI_WindowPtr My_CreateGads(EI_WindowPtr Window);

/*
**  Global Variabelen
*/

int                  dummy;
struct EI_Window    *Window=NULL;
EB_GadContext        GadCon=NULL;

/*
 * The EGS Lib-Bases
 *
 */

struct Library *EGSBase;
struct Library *EGSBlitBase;
struct Library *EGSLayersBase;
struct Library *EGSGfxBase;
struct Library *EGSIntuiBase;
struct Library *EGSRequestBase;
struct Library *EGBBase;
struct Library *EGBMenuSelectBase;
struct Library *EGBRadioBase;
struct Library *EGBScrollBase;
struct Library *EGBSelectBase;
struct Library *EGBSetBase;
struct Library *EGBTextInfoBase;
struct Library *EGBTwoDimPropBase;

/****************************************************************/

struct OpenStructType
{
	ULONG *Base;
	char  *Name;
	ULONG  Version;
};


struct OpenStructType OpenStruct[] =
{
  { (ULONG*) &EGSBase          , "egs.library",0               },
  { (ULONG*) &EGSBlitBase      , "egsblit.library",0           },
  { (ULONG*) &EGSLayersBase    , "egslayers.library",0         },
  { (ULONG*) &EGSGfxBase       , "egsgfx.library",0            },
  { (ULONG*) &EGSIntuiBase     , "egsintui.library",0          },
  { (ULONG*) &EGBBase          , "egsgadbox.library",0         },
  { (ULONG*) &EGSRequestBase   , "egsrequest.library",0        },
  { (ULONG*) &EGBMenuSelectBase, "egb/gbmenuselect.library",0  },
  { (ULONG*) &EGBRadioBase     , "egb/gbradio.library",0       },
  { (ULONG*) &EGBScrollBase    , "egb/gbscrollbox.library",0   },
  { (ULONG*) &EGBSelectBase    , "egb/gbselect.library",0      },
  { (ULONG*) &EGBSetBase       , "egb/gbsets.library",0        },
  { (ULONG*) &EGBTextInfoBase  , "egb/gbtextinfo.library",0    },
  { (ULONG*) &EGBTwoDimPropBase, "egb/gbtwodimprop.library",0  },
  { 0L,0L,0L }
};

/****************************************************************/

/*
**  Error Flags
*/

#define  ERR_LIBS     0x00000001
#define  ERR_FONTS    0x00000002
#define  ERR_MENUS    0x00000004
#define  ERR_GADGETS  0x00000008
#define  ERR_NOMEM    0x00000010
#define  ERR_WINDOW   0x00000020
#define  ERR_UNKNOWN  0x10000000

struct ErrorStructType
{
	char   *Err_Msg;
	ULONG   Err_no;
};


struct ErrorStructType ErrorStruct[] =
{
  {"Unknown error !"        ,ERR_UNKNOWN },
  {"Can't open Libraries !" ,ERR_LIBS    },
  {"Can't open Fonts !"     ,ERR_FONTS   },
  {"Can't create Menus !"   ,ERR_MENUS   },
  {"Can't create Gadgets !" ,ERR_GADGETS },
  {"Can't get Memory !"     ,ERR_NOMEM   },
  {"Can't open Window !"    ,ERR_WINDOW  },
  { 0L, NULL }
};

/****************************************************************/

/*
**  NewWindow Structure
**
*/

struct EI_NewWindow newwin =
{
  100     ,                       /* left border of window*/
  100     ,                        /* top edge of window */

  300     ,                       /* ... */
  300     ,                       /* ... */

  300     ,                       /* MinWidth  */
  300     ,                       /* MinHeight */
  800,                            /* MaxWidth  */
  600,                            /* MaxHeight */
  NULL,                           /* Screen    */
				  /* sysGadget */

   EI_WINDOWDRAG |
   EI_WINDOWCLOSE | EI_WINDOWSIZE |
   EI_WINDOWFRONT | EI_WINDOWBACK,

  NULL,                           /* EI_GadgetPtr -> gadgets   */
				  /* FirstGadget */
  "Titel",                        /* Titel                     */

				  /* Flags  */

   EI_WINDOWACTIVE     |   EI_WINDOW_MENULOCAL |
   EI_FRONTBACKGADGET  |   EI_WINDOWCENTER     |
   EI_SIMPLE_REFRESH   |   EI_GIMMEZEROZERO    |
   EI_SIZEBRIGHT       ,
				  /* IDCMP -Flags */
  EI_iCLOSEWINDOW |  EI_iMOVEWINDOW  |
  EI_iSIZEVERIFY  |  EI_iNEWSIZE     |
  EI_iMENUPICK,

  NULL,                           /* MsgPort *p    */
				  /* Windowcolors  */
  { 3 ,1 ,0 ,2 ,1 ,3 ,1 },        /* WinColors     */
  NULL,                           /* MenuPtr       */
  NULL                            /* IntuiGfxPtr   */
};

/****************************************************************/

/*
**
**  My Gadget Ids
**
*/

#define MY_2DPROP   0x00000010
#define MY_PROP     0x00000020
#define MY_INT      0x00000030
#define MY_ACTION   0x00000040
#define MY_ACTION1  0x00000050
#define MY_CHECK    0x00000060
#define MY_BUTTON   0x00000070
#define MY_TEXTBOOL 0x00000080
#define MY_STR      0x00000090
#define MY_ALL      0x00000100

/**/


