/*
*
*  $
*  $ FILE     : two.c
*  $ VERSION  : 1
*  $ REVISION : 13
*  $ DATE     : 08-Dec-93 13:16
*  $
*  $ Author   : mvk
*  $
*
**
**
** This demo showes you how you added horizontal and vertical
** boxes together.
** We create two horizontal boxes and one vertical box.
** After this we added some gadgets into the horizontal boxes then we add
** the two horizontal boxes into the vertical box.
**
** The example creates the following window contents
**
**    Window
**   ###################################
**   #                                 # \
**   # ++++++++++++++  +++++++++++++   #  \
**   # + String1    +  + String2   +   #   \  horizontal box  = hbox
**   # +            +  +           +   #   /
**   # ++++++++++++++  +++++++++++++   #  /
**   #                                 # /
**   #         ++++++  ++++++          # \
**   #         +    +  +    +          #  \
**   #         +    +  +    +          #   \  horizontal box 1 = hbox1
**   #         ++++++  ++++++          #   /
**   #                                 #  /
**   #                                 # /
**   #              ++++               #
**   #              ++++               #         ButtonGadget
**   #                                 #
**   ###################################
**                                             \ \\\   /// /
**                                          all 3 think are in a
**                                           verti box added
**
**  (c) by VIONA-Development 92/93
**
*/

/*
**
** This function are for all example the same
**
*/

#include "Includes.c"
#include "Global.h"
#include "Open_Close.c"
#include "Eventloop.c"

/**/


/*
**
** I this function creates the Gadget with egsgadbox.library
**
*/

EI_WindowPtr My_CreateGads(EI_WindowPtr Window)
{
     EB_GadBoxPtr   vbox,hbox,hbox1;
     EB_StrArray    gad={"String1","String2",NULL};

     /*
     **
     **  Create Gadget ( CadContext GadCon see global.h )
     **
     */

      if( (GadCon=EB_CreateGadContext(NULL,NULL,-1,-1)) == NULL)
	  myCleanExit(ERR_NOMEM);

	/*
	** Create a Horizontal or Vertical box
	*/

	vbox  = EB_CreateVertiBox( GadCon );
	hbox  = EB_CreateHorizBox( GadCon );
	hbox1 = EB_CreateHorizBox( GadCon );

	if( vbox == NULL || hbox == NULL || hbox1 == NULL)
	  myCleanExit(ERR_NOMEM);

	/*
	**  Add in the Horiz Box a MarkGadget (EI_BoolGadget)
	*/

	EB_AddLastSon( hbox, EB_CreateCheckMarkGadget(GadCon,MY_CHECK)  );
	EB_AddLastSon( hbox, EB_CreateCheckMarkGadget(GadCon,MY_CHECK+1));

	/*
	**  Add A ButtonGadget on the Horiz Box hbox1
	*/

	EB_AddLastSon( hbox1, EB_CreateButtonGadget(GadCon,MY_BUTTON)  );

	/*
	**  Add a MultiActionGadget on a Vertical Box
	*/

	EB_AddLastSon(vbox,EB_CreateMultiAction( GadCon, &gad, MY_ACTION,
							       EB_FILL_ALL));
	/*
	**
	** Add the Horiz Box  (hbox and hbox1) on the Verti Box
	**
	*/

	EB_AddLastSon( vbox,hbox  );
	EB_AddLastSon( vbox,hbox1 );

	/*
	**
	** ProcessGadBoxes calculate everything for the Gadget(s) (Positions)
	**
	*/

	if( EB_ProcessGadBoxes(GadCon,vbox) )
	{
	  /*
	  **  Filling in the EI_NewWindow structure
	  */

	  /*
	  **  The we open the window with the Context
	  */

	  if( Window == NULL )
	    {
						  /* Add more flags to the window */
	      GadCon->NewWin->Title = "two";

	      GadCon->NewWin->IDCMPFlags          = EI_iCLOSEWINDOW  |
						    EI_iGADGETUP;

	      GadCon->NewWin->Bordef.SysGadgets  |= ( EI_WINDOWCLOSE );

	      Window = EI_OpenWindow( GadCon->NewWin );

	    }

	  return(Window);
	}
    return(NULL);
}



int main(int argc, char *argv[])
{
     /*
     **   Open Library
     **
     */

     if ( InitLibraries(OpenStruct) == FALSE )
	  myCleanExit( ERR_LIBS );

	  /*
	  **  Makegadgets
	  */

	  Window=My_CreateGads(Window);

	  if( Window )
	    {
		 /*
		 **  Handels IDCMP events (like Commodore)
		 */

		 HandleEvents( Window );

	     }else{ myCleanExit( ERR_WINDOW );}

      myCleanExit( NULL ) ;
}



