#/*
*  $
*  $ FILE     : Programmieren:C-work/EGS-Beispiele/global.h
*  $ VERSION  : 1
*  $ REVISION : 1
*  $ DATE     : 16-Mar-93 16:59
*  $
*  $ Author   : mvk
*  $
*
* (c) by VIONA-Development 1992/93
*
*/

/*
**
**  my protos
**
*/

BOOL InitLibraries(struct OpenStructType *);
void CloseLibraries(struct OpenStructType *);
void myCleanExit(ULONG ERR);
EI_WindowPtr My_CreateGads(EI_WindowPtr Window);
void GetGadgetData( EB_GadContext GadCon);
void PutGadgetData( EB_GadContext GadCon);

/*
**  Global Variabelen
*/

int                  dummy;
struct EI_Window    *Window=NULL;
EB_GadContext        GadCon=NULL;

/*
 * The EGS Lib-Bases
 *
 */

struct Library *EGSBase;
struct Library *EGSBlitBase;
struct Library *EGSLayersBase;
struct Library *EGSGfxBase;
struct Library *EGSIntuiBase;
struct Library *EGSRequestBase;
struct Library *EGBBase;
struct Library *EGBMenuSelectBase;
struct Library *EGBRadioBase;
struct Library *EGBScrollBase;
struct Library *EGBSelectBase;
struct Library *EGBSetBase;
struct Library *EGBTextInfoBase;
struct Library *EGBTwoDimPropBase;

/****************************************************************/

struct OpenStructType
{
	ULONG *Base;
	char  *Name;
	ULONG  Version;
};


struct OpenStructType OpenStruct[] =
{
  { (ULONG*) &EGSBase          , "egs.library",0               },
  { (ULONG*) &EGSBlitBase      , "egsblit.library",0           },
  { (ULONG*) &EGSLayersBase    , "egslayers.library",0         },
  { (ULONG*) &EGSGfxBase       , "egsgfx.library",0            },
  { (ULONG*) &EGSIntuiBase     , "egsintui.library",0          },
  { (ULONG*) &EGBBase          , "egsgadbox.library",0         },
  { (ULONG*) &EGSRequestBase   , "egsrequest.library",0        },
  { (ULONG*) &EGBMenuSelectBase, "egb/gbmenuselect.library",0  },
  { (ULONG*) &EGBRadioBase     , "egb/gbradio.library",0       },
  { (ULONG*) &EGBScrollBase    , "egb/gbscrollbox.library",0   },
  { (ULONG*) &EGBSelectBase    , "egb/gbselect.library",0      },
  { (ULONG*) &EGBSetBase       , "egb/gbsets.library",0        },
  { (ULONG*) &EGBTextInfoBase  , "egb/gbtextinfo.library",0    },
  { (ULONG*) &EGBTwoDimPropBase, "egb/gbtwodimprop.library",0  },
  { 0L,0L,0L }
};

/****************************************************************/

/*
**  Error Flags
*/

#define  ERR_LIBS     0x00000001
#define  ERR_FONTS    0x00000002
#define  ERR_MENUS    0x00000004
#define  ERR_GADGETS  0x00000008
#define  ERR_NOMEM    0x00000010
#define  ERR_WINDOW   0x00000020
#define  ERR_UNKNOWN  0x10000000

struct ErrorStructType
{
	char   *Err_Msg;
	ULONG   Err_no;
};


struct ErrorStructType ErrorStruct[] =
{
  {"Unknown error !"        ,ERR_UNKNOWN },
  {"Can't open Libraries !" ,ERR_LIBS    },
  {"Can't open Fonts !"     ,ERR_FONTS   },
  {"Can't create Menus !"   ,ERR_MENUS   },
  {"Can't create Gadgets !" ,ERR_GADGETS },
  {"Can't get Memory !"     ,ERR_NOMEM   },
  {"Can't open Window !"    ,ERR_WINDOW  },
  { 0L, NULL }
};

/****************************************************************/
/****************************************************************/

/*
**
**  My Gadget Ids
**
*/

#define MY_2DPROP   0x00000010
#define MY_PROP     0x00000020
#define MY_INT      0x00000030
#define MY_ACTION   0x00000040
#define MY_ACTION1  0x00000050
#define MY_CHECK    0x00000060
#define MY_BUTTON   0x00000070
#define MY_TEXTBOOL 0x00000080
#define MY_STR      0x00000090
#define MY_ALL      0x00000100

/*
**
** Structure for GadgetData (Get/Put)
**
*/
struct GadDataStruct
{
      WORD  tdpg_HValue,tdpg_VValue;    // TwoDimPropGadget
      BYTE  act1_Flag;                  // ActionGadget  1
      BYTE  act2_Flag;                  //               2
      BYTE  butg_Flag;                  // ButtonGadget
      BYTE  mark_Flag;                  // CheckMark
      WORD  prop_Value;                 // HorizProp
      LONG  intg_Value;                 // IntGadget
      char  strg_Value[20];             // StringGadget
      BYTE  txtb_Flag;                  // TextBool
};

struct GadDataStruct GadData;

/**/


