/*
*  $
*  $ FILE     : menuselect.c
*  $ VERSION  : 1
*  $ REVISION : 6
*  $ DATE     : 08-Dec-93 14:22
*  $
*  $ Author   : mvk
*  $
*
*  This Programm shows how you can create a MenuSelectgadget
*  and handel the Gadget Messages.
*  refer to radio.c also
*/

/*
    Related Files: menuselect.doc, menuselect.h <- Our radio gadget
		   egsintui.doc, egsintui.h  <- window stuff
		   egsgadbox.doc, egsgadbox.h <- The actual gadbox
 main.c
***/

#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <dos/dos.h>
#include <exec/memory.h>
#include <proto/dos.h>
#include <proto/exec.h>

#include <egs/egs.h>
#include <egs/egsintui.h>
#include <egs/egsgadbox.h>
#include <egs/egb/gbmenuselect.h>
#include <egs/proto/all.h>


struct Library *EGSIntuiBase=NULL;       // EGSIntuition
struct Library *EGBMenuSelectBase=NULL;  // MenuSelect
struct Library *EGBBase=NULL;            // gadbox

/*
**  Protos
*/

EI_WindowPtr MenuSelectWindow (EI_WindowPtr win);
void Clean_Exit (void);

EB_GadContext GadCon;
EI_WindowPtr window;

void main (void) {

   EI_EIntuiMsgPtr msg;
   int class;
   struct EI_Gadget *iaddress;

   if (!(EGSIntuiBase = OpenLibrary ("egsintui.library",0))) {
     printf ("Unable open egsintui.library.\n");
     Clean_Exit ();
   }
   if (!(EGBBase = OpenLibrary ("egsgadbox.library",0))) {
     printf ("Unable open egsgadbox.library.\n");
     Clean_Exit ();
   }
   if (!(EGBMenuSelectBase = OpenLibrary ("egb/gbmenuselect.library",0))) {
     printf ("Unable open gbmenuselect.library.\n");
     Clean_Exit ();
   }


   if (!(window = MenuSelectWindow (NULL))) {
     printf ("Unable to open Window.\n");
     Clean_Exit ();
   }

   for (;;) {  // Forever

     Wait (1<<window->UserPort->mp_SigBit);      // wait for our signals

     while ( (msg=(struct EI_EIntuiMsg *) GetMsg (window->UserPort)) != NULL) {
       class = msg->Class;
       iaddress = (struct EI_Gadget *)msg->IAddress;

       ReplyMsg ( (struct Message *)msg);

       switch (class) {

	 case EI_iCLOSEWINDOW:
	    Clean_Exit ();
	 break;
			      // User has begun to resize window
	 case EI_iSIZEVERIFY:
	     EI_LockIntuition ();
	     EI_RemoveGList (window,GadCon->First, GadCon->Num);
	     EB_DeleteGadContext (GadCon);
	     EI_UnlockIntuition ();
	 break;

	 case EI_iNEWSIZE:
	     EI_LockIntuition ();
	     window = MenuSelectWindow (window);
	     EI_AddGList (window,GadCon->First,GadCon->Num);
	     EI_UnlockIntuition ();
	  break;

	  case EI_iGADGETDOWN:  // User has pressed a radio gadget
	     switch ( ((EGB_MenuGadgetPtr)iaddress)->Sel) {
	       case 0: printf ("First menu hit.\n"); break;
	       case 1: printf ("Second menu hit.\n"); break;
	       case 2: printf ("Third menu hit.\n"); break;
	       case 3: printf ("Fourth menu hit.\n"); break;
	       case 4:        // If user presses fifth, make all selectable
		  printf ("Fith menu hit.\n");
	       break;
	     }
	  break;

       }
     }
   }
 }

/*
**
** Create Menuselelect Gadget
**
*/

EI_WindowPtr MenuSelectWindow (EI_WindowPtr win) {
   EB_GadBoxPtr root;

   EB_StrArray menugads =
	       {"One","Two","three","Four","Five",NULL};

   GadCon = EB_CreateGadContext (NULL,NULL,-1,-1);

   root = EB_CreateHorizBox (GadCon);
   EB_AddLastSon (root,EB_CreateHorizFill (GadCon,0,0));
   EB_AddLastSon (root,EGB_CreateMenuGadget (GadCon,0x10,&menugads));
   EB_AddLastSon (root,EB_CreateHorizFill (GadCon,0,0));

   root = EB_CreateMasterWindow (GadCon,win,root);

   if (EB_ProcessGadBoxes (GadCon,root)) {
    if (win==NULL) {
      GadCon->NewWin->IDCMPFlags         = EI_iCLOSEWINDOW | EI_iSIZEVERIFY |
					   EI_iNEWSIZE     | EI_iGADGETUP |
					   EI_iGADGETDOWN;

      GadCon->NewWin->Bordef.SysGadgets |= (EI_WINDOWCLOSE)|(EI_WINDOWSIZE);

      GadCon->NewWin->Flags             |= (EI_SIZEBBOTTOM | EI_GIMMEZEROZERO);
      return (EI_OpenWindow (GadCon->NewWin));
    }
    else {
      return (win);
    }
  }
  else
    return NULL;
}

void Clean_Exit (void) {

    if (window)
      EI_CloseWindow (window);
    if (GadCon)
      EB_DeleteGadContext (GadCon);
    if (EGBBase)
      CloseLibrary (EGBBase);
    if (EGBMenuSelectBase)
      CloseLibrary (EGBMenuSelectBase);
    if (EGSIntuiBase)
      CloseLibrary (EGSIntuiBase);

    exit (0);
}
