/*
*  $
*  $ FILE     : textinfo.c
*  $ VERSION  : 1
*  $ REVISION : 9
*  $ DATE     : 08-Dec-93 15:19
*  $
*  $ Author   : mvk
*  $
*
*  This is an example for gbtextinfo.library
*
*  It create a TextInfo Gadget. This is a text with a
*  scrollbox and a slider, so that the user can scroll the
*  text by himselef, if its necessary. You must not handle the
*  TextInfo gadget the system made it for you.
*
*/
/*
    Related Files: gbtextinfo.doc, gbtextinfo.h <- Our Scrollbox gadget
		   egsintui.doc, egsintui.h  <- window stuff
		   egsgadbox.doc, egsgadbox.h <- The actual gadbox
 main.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <dos/dos.h>
#include <exec/memory.h>
#include <proto/dos.h>
#include <proto/exec.h>
#include <egs/egs.h>
#include <egs/egsintui.h>
#include <egs/egsgadbox.h>
#include <egs/egb/gbtextinfo.h>
#include <egs/proto/all.h>

/*
**  Protos
*/
EI_WindowPtr CreateTextInfoWindow (EI_WindowPtr win);
APTR My_FindGadget(EB_GadContext GadCon,WORD ID);
void Clean_Exit (void);

struct Library *EGSIntuiBase=NULL;         // EGSIntuition
struct Library *EGBTextInfoBase=NULL;      // TextInfoBox
struct Library *EGBBase=NULL;              // gadbox

EB_GadContext GadCon;
EI_WindowPtr window;
char         Text[]="Das ist ein Informationstext in Deutsch.\nLeider hat \
dieser Informationstext keinen informativen Inhalt,\ndeswegen wird er auch \
Quatsch-Text genannt, weil der Text nichts,\naber auch wirklich nichts,\
 informatives enthlt. ";

void main (void) {
   EI_EIntuiMsgPtr msg;
   int class;
   struct EI_Gadget *iaddress;

   if (!(EGSIntuiBase = OpenLibrary ("egsintui.library",0))) {
     printf ("Unable open egsintui.library.\n");
     Clean_Exit ();
   }
   if (!(EGBBase = OpenLibrary ("egsgadbox.library",0))) {
     printf ("Unable open egsgadbox.library.\n");
     Clean_Exit ();
   }

   if (!(EGBTextInfoBase = OpenLibrary ("egb/gbtextinfo.library",0))) {
     printf ("Unable open gbtextinfo.library.\n");
     Clean_Exit ();
   }

   if (!(window = CreateTextInfoWindow (NULL))) {
     printf ("Unable to open Window.\n");
     Clean_Exit ();
   }

   for (;;) {  // Forever

     Wait (1<<window->UserPort->mp_SigBit);  // wait for our signals

     while ( (msg=(struct EI_EIntuiMsg *) GetMsg (window->UserPort)) != NULL) {

       class    = msg->Class;
       iaddress = (struct EI_Gadget *)msg->IAddress;

       switch (class) {

       case EI_iCLOSEWINDOW:
            ReplyMsg ( (struct Message *)msg);
            Clean_Exit ();
       break;
              // User has begun to resize window
       case EI_iSIZEVERIFY:
           EI_LockIntuition ();
           EI_RemoveGList (window,GadCon->First, GadCon->Num);
           EB_DeleteGadContext (GadCon);
           EI_UnlockIntuition ();
           ReplyMsg ( (struct Message *)msg);
       break;

       case EI_iNEWSIZE:
           EI_LockIntuition ();
           window = CreateTextInfoWindow (window);
           EI_AddGList( window,GadCon->First,GadCon->Num );
           EI_UnlockIntuition ();
           ReplyMsg ( (struct Message *)msg);

        break;

       }
     }
   }
 }

/*
** CreateTextInfoGadgets
*/

EI_WindowPtr CreateTextInfoWindow (EI_WindowPtr win)
{
   EB_GadBoxPtr root;

   GadCon = EB_CreateGadContext (NULL,NULL,-1,-1);

   root = EB_CreateHorizBox (GadCon);
   EB_AddLastSon (root,EB_CreateHorizFill (GadCon,EB_FILL_ALL,0));
   EB_AddLastSon (root,EGB_CreateTextInfoGadget (GadCon,10,35,5,20,NULL,0x200));
   EB_AddLastSon (root,EB_CreateHorizFill (GadCon,EB_FILL_ALL,0));

   root = EB_CreateMasterWindow (GadCon,win,root);

   if (EB_ProcessGadBoxes (GadCon,root))
   {

    EGB_ModifyTextInfoGadget(NULL,My_FindGadget(GadCon,0x200),Text);

    if (win==NULL) {
      GadCon->NewWin->IDCMPFlags         = EI_iCLOSEWINDOW |
      																																     EI_iSIZEVERIFY  |
                                   					   EI_iNEWSIZE     |
                                      		   EI_iGADGETDOWN;

      GadCon->NewWin->Bordef.SysGadgets |= (EI_WINDOWCLOSE)|
                                           (EI_WINDOWSIZE);

     /*
     **  EI_GIMMEZEROZERO is required for a sizeable GadBox
     */

      GadCon->NewWin->Flags       |= (EI_SIZEBBOTTOM | EI_GIMMEZEROZERO);

      win=EI_OpenWindow (GadCon->NewWin);

    }

    return (win);

  }else
    return NULL;
}

/*
**
** This function searched for Subgadget in a MasterGadget,
** because all Gadgets are in a MasterWindow.
**
*/
APTR My_FindGadget(EB_GadContext GadCon,WORD ID)
{
	/*
	** MasterGadPtr because the window is create with
	** EB_CreateMasterWindow function
	*/
	return( EB_FindGadget(
		((EI_MasterGadPtr)GadCon->First)->FirstSon,
		((EI_MasterGadPtr)GadCon->First)->NumSons,ID));
}

void Clean_Exit (void) {

    if (window)
      EI_CloseWindow (window);
    if (GadCon)
      EB_DeleteGadContext (GadCon);
    if (EGBBase)
      CloseLibrary (EGBBase);
    if (EGBTextInfoBase)
      CloseLibrary (EGBTextInfoBase);
    if (EGSIntuiBase)
      CloseLibrary (EGSIntuiBase);

    exit (0);
}
