 /*
*
*  $
*  $ FILE     : gadget.c
*  $ VERSION  : 1
*  $ REVISION : 36
*  $ DATE     : 08-Dec-93 15:22
*  $
*  $ Author   : mvk
*  $
*
*
* This is a demo program about EGS TwoDimProp Gadget.
*
*
*
*  (c) by VIONA-Development 92/94
*
*/

#include "includes.c"
#include "Global.h"
#include "Eventloop.c"

BOOL InitLibraries(struct OpenStructType *);
void CloseLibraries(struct OpenStructType *);

/*
**  Opens the libs form the OpenStructType
**  (see global.h)
**
*/
BOOL InitLibraries(struct OpenStructType *OS)
{
 struct OpenStructType *p = &OS[0];

 while (p->Base != NULL)
 {
   if ((*(p->Base) = (ULONG)OpenLibrary(p->Name,p->Version)) == NULL)
       {
           printf(" Can't open %s version %d",p->Name, p->Version);
           return FALSE;
       }
       else
       {  p ++; }
 }
   return TRUE;
}


/*
** Close the Libs from the OpenStructType
**
*/
void CloseLibraries(struct OpenStructType *OS)
{
 struct OpenStructType *p = &OS[0];

 while (p->Name != NULL)
 {
        CloseLibrary((void *)(*(p->Base)));
        *(p->Base) = NULL;
        p++;
 }
}
/**/

/*
**  Looks what happend and deallocated all mem
**  fonts etc.
**
*/
void myCleanExit(ULONG ERR)
{

  int i=0;

    if( ERR )
    {
          while ( ErrorStruct[i].Err_Msg != NULL )
          {
             if( ERR & ErrorStruct[i].Err_no)
                   printf("%s\n",ErrorStruct[i].Err_Msg);
            i++;
          }
    }

  CloseLibraries(OpenStruct);

 exit(0);
}

/**/

int main(int argc, char *argv[])
{
     EB_GadContext  con;
     EB_GadBoxPtr   root;

      if ( InitLibraries(OpenStruct) == FALSE)
          myCleanExit(ERR_LIBS);

      if( (con=EB_CreateGadContext(NULL,NULL,-1,-1)) == NULL)
          myCleanExit(ERR_NOMEM);

        root = EGB_CreateTwoDPropGadget(con,100,10,1,100,10,1,13);

        root = EB_NewMinWidth(root,100);
        root = EB_NewMinHeight(root,100);

        root = EB_CreateMasterWindow(con,Window,root);

        if( !(EB_ProcessGadBoxesSize(con,root,100,100) ))
        {
           myCleanExit( ERR_UNKNOWN | ERR_NOMEM ) ;
        }else{
          /*
          **  Filling in the EI_NewWindow structure
          */

          if( Window == NULL )
            {
                                            /* Add more flags to the window */
              con->NewWin->Title = "TwoDimPropGadget";

              con->NewWin->IDCMPFlags         = EI_iCLOSEWINDOW  |
                                                EI_iMOUSEBUTTONS |
                                                EI_iMOUSEMOVE    |
                                                EI_iGADGETUP;

              con->NewWin->Bordef.SysGadgets  |= (EI_WINDOWCLOSE );

              con->NewWin->MaxWidth           = 800;
              con->NewWin->MaxHeight          = 600;
              con->NewWin->LeftEdge           = 100;
              con->NewWin->TopEdge            = 100;
              con->NewWin->Height             = 200;
              con->NewWin->Width              = 200;
              con->NewWin->Flags             |= (EI_SIZEBRIGHT);
              con->NewWin->Menu               = NULL;

              Window = EI_OpenWindow( con->NewWin );
            }

          if( Window )
            {
              HandleEvents( Window );

              if( Window )
                 EI_CloseWindow( Window );

             }else{ myCleanExit( ERR_WINDOW );}

          if( con )
              EB_DeleteGadContext( con );

             myCleanExit( NULL );

         }
}



