/*
** Author: Markus van Kempen
** Date  : 17. Dezember 1992
**
** Input : EG_EFontPtr = Point to a Font for Menu
** Output: EI_MenuPtr  = Point to the Menu-Structure
**                       for assign to the EI_NewWindow-Structure
**                       --> "newWindow.menu=menu"
**
** This is a routine to initialize a menu structure.
** It calls functions from the egsintui.library.
** If you want to change the menus, you only
** have to change this file.
**
**
** (c) by VIONA-Development 1992/93
**
*/

EI_MenuPtr        EI_CreateMenu(void);
EI_MenuItemPtr    EI_CreateLeave(void);

EI_MenuPtr InitMenu(EG_EFontPtr font)
{

  EI_MenuPtr      menu;
  EI_MenuItemPtr  item1,item2;
  struct TextAttr *attr;

  if(font == NULL)
  {
     attr = (struct TextAttr *) EI_GetPrefFont(1);
     font = (EG_EFontPtr)       EG_OpenFont(attr);

  }

 /** Create a complex menu, which will look like this

    +----------------------------+------------+
    | Project                    | Flags      |
    +------------+---------------+-----------++
    +------------+               +-----------+
    | Load     O |               | -/ Flag 1 |
    |  Save... > +--------------+| -/ Flag 2 |
    | Rename     | Save       S ||    Flag 3 |
    | New      N | Save as    A ||    Flag 4 |
    | Close    X | Save & Close ||    Flag 5 |
    | About      +--------------+|    Flag 6 |
    | Quit     Q |               |    Flag 7 |
    +------------+               +-----------+

 **/

  menu  = EI_CreateMenu();
    item1 = EI_CreateItem(font,"Project",0,0,0);
      EI_AddToItem(item1,EI_CreateLeave());
      EI_AddToItem(item1,EI_CreateItem(font,"Load", 0x1,'O',0));
    item2=EI_CreateItem(font,"Save",0x10,0,0);
      EI_AddToItem(item2,EI_CreateItem(font,"Save"         ,0x11,'S',0));
      EI_AddToItem(item2,EI_CreateItem(font,"Save as"      ,0x12,'A',0));
      EI_AddToItem(item2,EI_CreateItem(font,"Save & Close" ,0x13,'C',0));
    EI_AddToItem(item1,item2);
      EI_AddToItem(item1,EI_CreateItem(font,"New",  0x3,'N',0));
      EI_AddToItem(item1,EI_CreateItem(font,"Close",0x4,'X',0));
      EI_AddToItem(item1,EI_CreateItem(font,"About",0x5,NULL,0));
      EI_AddToItem(item1,EI_CreateItem(font,"Quit" ,0x6,'Q',0));
    EI_AddToMenu(menu,item1);
    item1 = EI_CreateItem(font,"Flags",0,0,0);
      EI_AddToItem(item1,EI_CreateLeave());
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 1",0x20,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 2",0x21,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 3",0x22,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 4",0x23,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 5",0x24,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 6",0x25,0,1));
      EI_AddToItem(item1,EI_CreateItem(font,"Flag 7",0x26,0,1));
    EI_AddToMenu(menu,item1);
  return(menu);
}
