
/**
 ** Example for 24-Bit-Modus; shows 2^24 color (or dithering)
 **
 **  Author          : D.H
 **  Change          : 14. Juli 1992 mvk
 **                  : 18 Dec 1992 SAS/C 6.0 mvk **
 **
 **
 **  (C) by VIONA-Development 1991,1993
 **
 **/

#include <stdio.h>
#include <stdlib.h>

#include <exec/exec.h>
#include <proto/exec.h>
#include <egs/egsintui.h>
#include <egs/proto/egs.h>
#include <egs/proto/egsgfx.h>
#include <egs/proto/egsintui.h>

EI_ScreenPtr Schirm;
struct Library *EGSIntuiBase,*EGSGfxBase,*EGSBase;
EG_RastPortPtr MeinRastPort;

#define WIDTH  800
#define HEIGHT 600

struct IG_WinColors color = {
      3,1,0,2,1,3,1
};

struct EI_NewScreen NeuerScreen = {
 NULL,                                         /* Screen */
 24,0,
 "Test Screen",
 NULL,                                         /* CLUPtr */
					       /* WinColors */
 {3,1,0,2,1,3,1},
 0,                                            /* backPen */
 NULL,                                         /* backPattern */
 NULL,                                         /* Maus */
 NULL                                          /* TextAttr */
};





void Crash (char *string)
{
 if (Schirm)
  EI_CloseScreen (Schirm);
 if (EGSBase)
  CloseLibrary (EGSBase);
 if (EGSIntuiBase)
  CloseLibrary (EGSIntuiBase);
 if (EGSGfxBase)
  CloseLibrary (EGSGfxBase);
 if (NULL == string)
  exit (0);
 else
  {
  printf ("%s.\n", string);
  exit (10);
  }
}





void ZeichneRaster (void)
{
 register LONG rot, gruen, blau, farbe;

 for (rot=0;  rot<64;  rot++)
  {
  for (gruen=0;  gruen<64;  gruen++)
   {
   for (blau=0;  blau<64;  blau++)
    {
    farbe = ((rot*4)<<24) + ((gruen*4)<<16) + ((blau*4)<<8);
    EG_SetAPen (MeinRastPort, farbe);
    if (rot%2 != 0)
     if ((rot/8)%2 != 0)
      EG_WritePixel (MeinRastPort,
      (WORD)(144+(rot%8)*63+gruen),
       (WORD)(44+(rot/8)*63+blau));
     else
      EG_WritePixel (MeinRastPort,
       (WORD)(144+(rot%8)*63+gruen),
       (WORD)(44+(rot/8)*63+(64-blau)));
    else
     if ((rot/8)%2 != 0)
      EG_WritePixel (MeinRastPort,
      (WORD)(144+(rot%8)*63+(64-gruen)),
      (WORD)(44+(rot/8)*63+blau));
     else
      EG_WritePixel (MeinRastPort,
      (WORD)(144+(rot%8)*63+(64-gruen)),
      (WORD)(44+(rot/8)*63+(64-blau)));
    }
   }
  }
}


void main (void)
{
 char ch;

 Schirm = NULL;
 EGSIntuiBase = NULL;
 EGSGfxBase = NULL;
 EGSBase = NULL;

 EGSBase =  OpenLibrary ("egs.library", 0);

 if (NULL == EGSBase)
  Crash ("Konnte egs.library nicht ffnen");

 EGSIntuiBase = OpenLibrary ("egsintui.library", 0);

 if (NULL == EGSIntuiBase)
  Crash ("Konnte EGSIntui.library nicht ffnen");

 EGSGfxBase = OpenLibrary ("egsgfx.library", 0);

 if (NULL == EGSGfxBase)
  Crash ("Konnte EGSGfx.library nicht ffnen");

 Schirm = EI_OpenScreen (&NeuerScreen);

 if (NULL == Schirm)
  Crash ("Konnte Schirm nicht ffnen");

 MeinRastPort = Schirm->RastPort;

 E_MouseOff(Schirm->EScreen);

 ZeichneRaster();

 E_MouseOn(Schirm->EScreen);

 printf ("Return drcken:");
 scanf ("%c", &ch);
 Crash (NULL);
}

