/*
*
*  $
*  $ FILE     : ScrMdReq.c
*  $ VERSION  : 1
*  $ REVISION : 12
*  $ DATE     : 08-Dec-93 19:30
*  $
*  $ Author   : mvk
*  $
*
**
**
**
** This is a demo program about EGS requester.library.
**
** This program shows how you can open and handle a EGS-ScreenMode
** requester.
**
*/

#include "Includes.c"
#include "Global.h"
#include "Open_Close.c"

/**/

int main(int argc, char *argv[])
{
     ER_ReqContextPtr rCon;
     ER_ScrModeReqPtr freq;
     BOOL             done;

     /*
     **   Open Libraries
     */

     if ( InitLibraries(OpenStruct) == FALSE )
       	  myCleanExit( ERR_LIBS );

     if ( rCon = ER_CreateReqContext()  )
      {
     	 if ( freq = ER_CreateScrModeReq(rCon)  )
          {

            freq->Req.Title         = "ScreenModeReq";
            freq->Req.Nw->LeftEdge  = 10;
            freq->Req.Nw->TopEdge   = 10;

            ER_PutValuesInScrModeReq(freq,"NEXT 1120x832",8);

            done= ER_DoRequest((ER_RequestPtr)freq);

            if ( done )
            {
               printf("ScreenMode  = %s\n",freq->ScreenMode);
               printf("ScreenDepth = %d\n",freq->Depth);
            }

          ER_DeleteRequest((ER_RequestPtr)freq);
        }

        ER_DeleteReqContext(rCon);

      }else{myCleanExit( ERR_CONTEXT );}

      myCleanExit( NULL );
}



