#ifndef CLIB_EGS_PROTOS_H
#define CLIB_EGS_PROTOS_H

/***************************************************************************\
*  $
*  $ FILE     : egs_protos.h
*  $ VERSION  : 2
*  $ REVISION : 3
*  $ DATE     : 08-Dec-93 13:47
*  $
*  $ Author   : mvk
*  $
*
*  C prototypes
*
*****************************************************************************
*                                                                           *
* (c) Copyright 1990/94 VIONA Development                                   *
*     All Rights Reserved                                                   *
*                                                                           *
\***************************************************************************/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EGS_EGS_H
#include        <egs/egs.h>
#endif

E_EScreenPtr E_OpenScreen (struct E_NewEScreen *scr);
void E_CloseScreen (E_EScreenPtr scr);
void E_MouseOn (E_EScreenPtr scr);
void E_MouseOff (E_EScreenPtr scr);
void E_ModifyMouse (E_EScreenPtr scr, E_EMousePtr mouse);
void E_ScreenToFront (E_EScreenPtr scr);
void E_ScreenToBack (E_EScreenPtr scr);
void E_ActivateEGSScreen (void);
void E_ActivateAmigaScreen (void);
void E_ModifyEDCMP (E_EScreenPtr scr, UWORD flags);
void E_DisposeBitMap (E_EBitMapPtr map);
void E_ClearBitMap (E_EBitMapPtr map);
void E_SetMouseExcept (APTR callMe, APTR data);         /* PRIVATE */
void E_ResetMouseExcept (void);                         /* PRIVATE */
void E_SetRGB8 (E_EScreenPtr scr, UWORD reg, UWORD red,
	UWORD green, UWORD blue);
ULONG E_GetRGB8 (E_EScreenPtr scr, WORD reg);
void E_SetRGB8CM (E_EScreenPtr scr, E_CLUPtr colors,
	  WORD start, WORD num);
void E_GetRGB8CM (E_EScreenPtr scr, E_CLUPtr colors,
	  WORD start, WORD num);
E_EBitMapPtr E_FlipMap (E_EScreenPtr scr, E_EBitMapPtr map);
E_HardInfoPtr E_GetHardInfo (void);

void E_OldWaitTOF (void); /* Change see below */

E_EBitMapPtr E_AllocBitMap (UWORD width, UWORD height, UWORD depth,
		ULONG type, ULONG flags, E_EBitMapPtr friend);

/* Device Libs */

E_EMemPoolPtr E_CreateEMemPool(APTR pos,LONG size);

VOID E_DeleteEMemPool(E_EMemPoolPtr pool);

BOOL E_AllocEMem(E_EMemPoolPtr pool,E_EMemPtr mem,LONG size);

VOID E_FreeEMem(E_EMemPoolPtr pool,E_EMemPtr mem);

E_EGSClassPtr E_ObtainPublicClass(E_Symbol name);

BOOL E_AddPublicClass(E_EGSClassPtr class, E_Symbol name);

E_Symbol E_GetSymbol(char *str);

VOID E_AddMethod(E_EGSClassPtr class, E_Symbol name, E_EGSCall call, APTR  data);

E_EGSClassPtr E_CreateSubClass(E_EGSClassPtr   super,
			       LONG            objectSize,
			       LONG            classSize,
			       E_MethodListPtr methods,
			       APTR            data);

BOOL E_Dispatch(E_EGSObjectPtr obj,
	      E_Symbol       name,
	      E_EGSObjMsgPtr msg);

BOOL  E_isSubClass(E_EGSClassPtr class,
		   E_EGSClassPtr of);

VOID E_SendEGSMsg(E_EScreenPtr scr,
		  WORD         x, WORD y,
		  ULONG        class,
		  UWORD        code,
		  ULONG        qualifier,
		  ULONG        seconds,
		  ULONG        micros,
		  LONG         doubleDead);

E_EBitMapPtr E_AllocBitMapFrame(E_EBitMapClassPtr class,
				WORD              w,
				WORD              h,
			       ULONG              flags);

VOID E_DisposeBitMapFrame(E_EBitMapPtr map);

E_EBitMapPtr E_AllocBitMapClass(UWORD  width,
				UWORD  height,
				ULONG  flags,
				E_EGSClassPtr class);

VOID E_MoveMouse(E_EScreenPtr scr,
		 WORD         x,
		 WORD         y);

BOOL E_AddPublicVideoNode(E_VideoNodePtr node);

VOID E_AddVideoLink(E_VideoNodePtr from,
		    E_VideoNodePtr to);

VOID E_RemVideoLink(E_VideoNodePtr from,
		    E_VideoNodePtr to);

VOID E_LockEGSVideo(VOID);

VOID E_UnlockEGSVideo(VOID);

VOID E_SetUserFocus(E_EScreenPtr scr);

BOOL E_CrossMouseBorder(E_EScreenPtr from,
			ULONG        direction);

BOOL E_AddScreenMode(E_ScreenModePtr mode);

VOID E_WaitTOF(E_EScreenPtr scr);

E_EScreenPtr E_WhichScreen(E_MonitorPtr moni);

E_MonitorPtr E_WhichMonitor(E_EScreenPtr scr);

BOOL E_CanDisplayOnMonitor(E_EScreenPtr scr,
			   E_MonitorPtr mon);

/* LIBRARY EGSBase BY -372 */

APTR E_CreateObject(E_EGSClassPtr class);

VOID E_DeleteObject(E_EGSObjectPtr obj);

E_VideoNodePtr E_FindPublicVideoNode(char *name);

ULONG E_NewMapType(VOID);

VOID  E_MouseOffRect(E_EScreenPtr   scr,
		     E_ClipRectPtr  rect);

VOID E_ObtainClass(E_EGSClassPtr class);

VOID E_ReleaseClass(E_EGSClassPtr class);

E_EGSClassPtr E_ObtainObjectClass(E_EGSObjectPtr obj);

char *E_GetSymName(E_Symbol sym);

VOID E_AddClassMethod(E_EGSClassPtr class,
		      E_Symbol      name,
		      E_EGSCall     call,
		      APTR  data);

BOOL E_DispatchClass(E_EGSClassPtr   class,
		     E_Symbol        name,
		     E_EGSObjMsgPtr  msg);

BOOL E_GetClassMethod(E_EGSClassPtr         class,
		      E_Symbol              sym,
		      struct E_EGSMethod    method);

BOOL E_isSubType(E_EGSObjectPtr obj,
		 E_EGSClassPtr  of);

E_MonitorSpecPtr E_CreateMonitorSpecTagList(char *name,
					    APTR Tags);

E_MonitorSpecPtr E_CreateMonitorSpecTags(char *name,
					 unsigned long tag1Type, ... );

VOID E_ChangeMonitorSpecTagList(E_MonitorSpecPtr moni,
				       APTR      Tags);

VOID E_ChangeMonitorSpecTags(E_MonitorSpecPtr moni,
			     unsigned long tag1Type, ... );

VOID E_SaveMonitorSpec(E_MonitorSpecPtr moni);

E_MonitorSpecPtr E_ObtainMonitorSpec(char *name);

VOID E_ReleaseMonitorSpec(E_MonitorSpecPtr moni);

VOID E_DeleteMonitorSpec(E_MonitorSpecPtr moni);

VOID E_RenameMonitorSpec(E_MonitorSpecPtr moni,
			 char            *name);

E_ScreenSpecPtr E_CreateScreenSpecTagList(E_MonitorSpecPtr moni,
					  APTR             tags);

E_ScreenSpecPtr E_CreateScreenSpecTags(E_MonitorSpecPtr moni,
				   unsigned long tag1Type, ... );

VOID E_DeleteScreenSpec(E_ScreenSpecPtr spec);

VOID E_ChangeScreenSpecTagList(E_ScreenSpecPtr spec,
			       APTR            tags);

VOID E_ChangeScreenSpecTags(E_ScreenSpecPtr spec,
			unsigned long tag1Type, ... );

E_ScreenSpecPtr E_ObtainScreenSpec(E_MonitorSpecPtr  moni,
				   char             *name);

VOID E_ReleaseScreenSpec(E_ScreenSpecPtr spec);

E_ScreenParamPtr E_CreateScreenParamTagList(E_ScreenSpecPtr spec,
					    APTR            tags);

E_ScreenParamPtr E_CreateScreenParamTags(E_ScreenSpecPtr spec,
				     unsigned long tag1Type, ... );

VOID E_DeleteScreenParam(E_ScreenParamPtr param);

VOID E_ChangeScreenParamTagList(E_ScreenParamPtr param,
				APTR             tags);

VOID E_ChangeScreenParamTags(E_ScreenParamPtr param,
			     unsigned long tag1Type, ... );

VOID E_GetRealTimings(E_DisplayDriverPtr   driver,
		      E_ScreenParamPtr     param,
		      E_ScreenParamPtr     real);

VOID E_AddMonitorSpec(E_DisplayDriverPtr driver,
		      E_MonitorSpecPtr   monitor);

VOID E_RemMonitorSpec(E_DisplayDriverPtr driver,
		      E_MonitorSpecPtr   moni);

VOID E_SaveMonitorPrefs(E_DisplayDriverPtr driver);
VOID E_LoadMonitorPrefs(E_DisplayDriverPtr driver);

E_EScreenPtr E_OpenScreenTagList(E_NewEScreenPtr  nscr,
				 APTR           tags);

E_EScreenPtr E_OpenScreenTags(E_NewEScreenPtr  nscr,
			 unsigned long tag1Type, ... );


VOID E_DefinePublicObject(E_PublicEGSObjectPtr obj, E_Symbol name);

E_PublicEGSObjectPtr E_ObtainPublicObject(E_Symbol name);

BOOL E_LoadDriver(char * name);

VOID E_ReloadPrefs(VOID);

VOID E_ReleasePublicObject(E_PublicEGSObjectPtr obj);

VOID E_ObtainObject(E_PublicEGSObjectPtr obj);

E_EGSObjectPtr E_CreateObjectMsg(E_EGSClassPtr class,
				 E_CreateMsgPtr msg);

#endif  /* CLIB_EGS_PROTOS_H */

