#ifndef CLIB_EGSBLIT_PROTOS_H
#define CLIB_EGSBLIT_PROTOS_H

/***************************************************************************\
*  $
*  $ FILE     : egsblit_protos.h
*  $ VERSION  : 1
*  $ REVISION : 3
*  $ DATE     : 08-Dec-93 13:46
*  $
*  $ Author   : mvk
*  $
*
*  C prototypes
*
*****************************************************************************
*                                                                           *
* (c) Copyright 1990/94 VIONA Development                                   *
*     All Rights Reserved                                                   *
*                                                                           *
\***************************************************************************/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EXEC_PORTS_H
#include        <exec/ports.h>
#endif
#ifndef         EGS_EGS_H
#include        <egs/egs.h>
#endif
#ifndef         EGS_EGSBLIT_H
#include        <egs/egsblit.h>
#endif

ULONG EB_ReadPixel (E_EBitMapPtr map, WORD x, WORD y);
void EB_WritePixel (E_EBitMapPtr map, ULONG c, WORD x, WORD y, ULONG mask);
void EB_InvertPixel (E_EBitMapPtr map, WORD x, WORD y);
void EB_Draw (E_EBitMapPtr map, ULONG c, WORD x1,
   WORD y1, WORD x2, WORD y2, ULONG mask);

void EB_DrawClipped (E_EBitMapPtr map, EB_ClipRectPtr rect,
      ULONG c, WORD x1, WORD y1, WORD x2,
      WORD y2, ULONG mask);

void EB_InvertRectangle (E_EBitMapPtr map, WORD left,
      WORD top, WORD right, WORD bottom);

void EB_RectangleFill (E_EBitMapPtr map, ULONG c,
        WORD left, WORD top,WORD width,
        WORD height, ULONG mask);

void EB_RectangleClipped (E_EBitMapPtr map, EB_ClipRectPtr rect,
       ULONG c, WORD left, WORD top,
       WORD width, WORD height, ULONG mask);

void EB_Write (E_EBitMapPtr map, EB_ColorDesPtr color,
    WORD x, WORD y, char* str, WORD len, ULONG mask);

void EB_WriteClipped (E_EBitMapPtr map, EB_ClipRectPtr rect,
       EB_ColorDesPtr color, WORD x, WORD y, char* str,
       WORD len, ULONG mask);

void EB_CopyBitMap (E_EBitMapPtr src, E_EBitMapPtr dst,
     WORD xs, WORD ys, WORD width, WORD height,
     WORD xd, WORD yd, ULONG mask);

void EB_CopyBitMapClipped (E_EBitMapPtr src, E_EBitMapPtr dst,
        EB_ClipRectPtr rect, WORD xs, WORD ys,
        WORD width, WORD height, WORD xd, WORD yd,
        ULONG mask);

void EB_FillMask (E_EBitMapPtr mask, E_EBitMapPtr dst,
   EB_ImageDesPtr pattern, WORD x, WORD y, ULONG mask2);

void EB_FillMaskClipped (E_EBitMapPtr mask, E_EBitMapPtr dst,
      EB_ImageDesPtr pattern, EB_ClipRectPtr clip,
      WORD x, WORD y, ULONG mask2);

E_EBitMapPtr EB_UnpackImage (EB_ImagePtr image, WORD depth,
   EB_ColorTablePtr colors);

void EB_BitAreaCircle (E_EBitMapPtr dst, WORD radius);

void EB_BitAreaPolygon (E_EBitMapPtr dst, EB_PolygonPtr poly,
     WORD range, WORD width, WORD height);

void EB_FloodFill (E_EBitMapPtr dst, EB_ClipRectPtr clip,
    ULONG color, WORD x, WORD y, ULONG mode);

void EB_ExtractColor (E_EBitMapPtr src, E_EBitMapPtr dst,
       ULONG color, WORD sx, WORD sy,
       WORD w, WORD h, WORD dx, WORD dy);

void EB_FloodOneBit (E_EBitMapPtr map, EB_ClipRectPtr clip,
      EB_ClipRectPtr dclip, WORD x, WORD y);

void EB_FloodZeroBit (E_EBitMapPtr map, EB_ClipRectPtr clip,
       EB_ClipRectPtr dclip, WORD x, WORD y);

void EB_DrawClippedPatt (E_EBitMapPtr map, EB_ClipRectPtr rect,
                         LONG front, LONG back, WORD x1, WORD y1,
                         WORD x2,    WORD y2, UWORD patt);

void EB_BitBlt(E_EBitMapPtr src,E_EBitMapPtr dst,WORD xs, WORD ys,
               WORD width, WORD height, WORD xd, WORD yd,
                                              UBYTE  MinTerm);

void EB_BitBltClipped(E_EBitMapPtr src,E_EBitMapPtr dst,E_ClipRectPtr rect,WORD xs, WORD ys,
               WORD width, WORD height, WORD xd, WORD yd,
                                              UBYTE  MinTerm);

#endif /* CLIB_EGSBLIT_PROTOS_H */

