#ifndef CLIB_EGSINTUI_PROTOS_H
#define CLIB_EGSINTUI_PROTOS_H

/***************************************************************************\
*  $
*  $ FILE     : egsintui_protos.h
*  $ VERSION  : 1
*  $ REVISION : 5
*  $ DATE     : 08-Dec-93 13:46
*  $
*  $ Author   : mvk
*  $
*
*  C prototypes
*
*****************************************************************************
*                                                                           *
* (c) Copyright 1990/94 VIONA Development                                   *
*     All Rights Reserved                                                   *
*                                                                           *
\***************************************************************************/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EXEC_PORTS_H
#include        <exec/ports.h>
#endif
#ifndef         DEVICES_INPUTEVENT_H
#include        <devices/inputevent.h>
#endif
#ifndef         GRAPHICS_TEXT_H
#include        <graphics/text.h>
#endif
#ifndef         EGS_EGS_H
#include        <egs/egs.h>
#endif
#ifndef         EGS_EGSBLIT_H
#include        <egs/egsblit.h>
#endif
#ifndef         EGS_EGSLAYERS_H
#include        <egs/egslayers.h>
#endif
#ifndef         EGS_EGSGFX_H
#include        <egs/egsgfx.h>
#endif
#ifndef         EGS_EGSINTUIGFX_H
#include        <egs/egsintuigfx.h>
#endif
#ifndef         EGS_EGSINTUI_H
#include        <egs/egsintui.h>
#endif

void EI_LockIntuition (void);
void EI_UnlockIntuition (void);
EI_ScreenPtr EI_OpenScreen (struct EI_NewScreen *newScreen);
void EI_CloseScreen (EI_ScreenPtr scr);
EI_WindowPtr EI_OpenWindow (struct EI_NewWindow *win);
void EI_CloseWindow (EI_WindowPtr win);
void EI_ActivateWindow (EI_WindowPtr win);
void EI_DeactivateWindow (EI_WindowPtr win);
void EI_WindowToFront (EI_WindowPtr win);
void EI_WindowToBack (EI_WindowPtr win);
void EI_MoveWindow (EI_WindowPtr win, WORD dx, WORD dy);
void EI_ScrollWindow (EI_WindowPtr win, WORD dx, WORD dy);
void EI_SizeWindow (EI_WindowPtr win, WORD dx, WORD dy);
void EI_WindowBorder (EI_WindowPtr win, WORD dx, WORD dy);
void EI_SetWindowTitles (EI_WindowPtr win, char *wTitle, char *sTitle);
ULONG EI_BeginRefresh (EI_WindowPtr win, LONG key);
void EI_EndRefresh (EI_WindowPtr win, ULONG ready);
void EI_RedrawGadgetList (EI_WindowPtr win, ULONG border, ULONG inside);
void EI_ActivateGadget (EI_WindowPtr win, EI_GadgetPtr gad, ULONG force);
void EI_AddGadget (EI_WindowPtr win, EI_GadgetPtr gad);
void EI_AddGList (EI_WindowPtr win, EI_GadgetPtr gad, WORD num);
void EI_RemoveGadget (EI_WindowPtr win, EI_GadgetPtr gad);
void EI_RemoveGList (EI_WindowPtr win, EI_GadgetPtr gad, WORD num);
void EI_RefreshGadget (EI_WindowPtr win, EI_GadgetPtr gad);
void EI_RefreshGList (EI_WindowPtr win, EI_GadgetPtr gad, WORD num);
void EI_OnGadget (EI_WindowPtr win, EI_GadgetPtr gad);
void EI_OnGList (EI_WindowPtr win, EI_GadgetPtr gad, WORD num);
void EI_OffGadget (EI_WindowPtr win, EI_GadgetPtr gad);
void EI_OffGList (EI_WindowPtr win, EI_GadgetPtr gad, WORD num);
void EI_PutMenuHome (EI_MenuPtr menu);
void EI_PutMenuOut (EI_MenuPtr menu, EI_WindowPtr win, WORD x, WORD y);
void EI_SetMenuStrip (EI_WindowPtr win, EI_MenuPtr menu);
void EI_SetPointer (EI_WindowPtr win, E_EMousePtr mouse);
void EI_ClearPointer (EI_WindowPtr win);
ULONG EI_DoubleClick (LONG StartSec, LONG StartMicros,
		      LONG EndSec, LONG EndMicros);
void EI_ModifyIDCMP (EI_WindowPtr win, ULONG flags);

void EI_ReportMouse (EI_WindowPtr win, BOOL flags);

void EI_Interpret (EG_RastPortPtr rast, IG_WinColorsPtr colors,
		   IG_IntuiGfxPtr toff, IG_IntuiGfxPtr prog,
		   WORD x, WORD y);
void EI_InterpretStacked (EG_RastPortPtr rast, IG_WinColorsPtr colors,
			  IG_IntuiGfxPtr prog, WORD x, WORD y);
void EI_Interpret1Param (EG_RastPortPtr rast, IG_WinColorsPtr colors,
			 IG_IntuiGfxPtr prog, WORD x, WORD y, LONG para1);
void EI_Interpret2Param (EG_RastPortPtr rast,
			 IG_WinColorsPtr colors, IG_IntuiGfxPtr prog,
			 WORD x, WORD y, LONG para1, LONG para2);
WORD EI_SysRequest (EI_WindowPtr win, char *title, char *bodyTxt, char *gadgTxt);
struct TextAttr *EI_GetPrefFont (ULONG type);
struct EI_NewScreen *EI_GetDefaultScreen(void);
void EI_RefreshWindow (EI_WindowPtr win);
void EI_RefreshScreen (EI_ScreenPtr scr);
void EI_SleepWindow (EI_WindowPtr win);
void EI_WakeWindow (EI_WindowPtr win);
ULONG EI_ObtainColor (EI_ScreenPtr scr, UBYTE r, UBYTE g, UBYTE b);
void EI_ReleaseColor (EI_ScreenPtr scr, ULONG color);
ULONG EI_GetWinColor (EI_ColorTablePtr colors, ULONG tag);
ULONG EI_GetDefaultColor (WORD depth, ULONG tag);
ULONG EI_CloneColor (EI_ScreenPtr scr, ULONG color);
EI_MenuItemPtr EI_FindMenuItem (EI_MenuPtr menu, LONG id);
EI_MenuPtr EI_FindSubMenu (EI_MenuPtr menu, LONG id);
void EI_ToggleMenuItem (EI_MenuPtr menu, EI_MenuItemPtr item);
void EI_OnMenuItem (EI_MenuPtr menu, EI_MenuItemPtr item);
void EI_OffMenuItem (EI_MenuPtr menu, EI_MenuItemPtr item);
void EI_FreeMenu(EI_MenuPtr menu);
EI_MenuPtr EI_CreateMenu(void);
void EI_AddToMenu(EI_MenuPtr menu, EI_MenuItemPtr item);
void EI_AddToItem(EI_MenuItemPtr item, EI_MenuItemPtr add);
EI_MenuItemPtr EI_CreateItem(EG_EFontPtr font, char *name, LONG id, char key, LONG toggle);
EI_MenuItemPtr EI_CreateLeave(void);
E_EMousePtr EI_GetPrefPointer(ULONG tag);
void EI_DragNDropClip(IG_IntuiGfxPtr draw, int ox, int oy, int w, int h,
		      EI_WindowPtr from, LONG type, LONG clipID);
void EI_DragNDropFile(IG_IntuiGfxPtr draw, int ox, int oy, int w, int h,
		      EI_WindowPtr from, LONG type, char *file);
void EI_DragNDropFiles(IG_IntuiGfxPtr draw, int ox, int oy, int w, int h,
		      EI_WindowPtr from, LONG type, char *files);
void EI_DragNDropData(IG_IntuiGfxPtr draw, int ox, int oy, int w, int h,
		      EI_WindowPtr from, LONG type, APTR data, LONG size);

LONG EI_GetPrefsColor(WORD depth,ULONG tag);
void EI_DeactivateGadget(void);
void EI_MigrateWindow(EI_WindowPtr win,EI_ScreenPtr scr, WORD x, WORD y);
void EI_SetMouseMoveIntervall(EI_WindowPtr win,LONG micro);

#endif /* CLIB_EGSINTUI_PROTOS_H */

