#ifndef EGS_EGSREQUEST_H
#define EGS_EGSREQUEST_H

/***************************************************************************\
*
*  $
*  $ FILE     : egsrequest.h
*  $ VERSION  : 1
*  $ REVISION : 9
*  $ DATE     : 08-Dec-93 12:45
*  $
*  $ Author   : mvk
*  $
*
*****************************************************************************
*                                                                           *
* (c) Copyright 1990/94 VIONA Development                                   *
*     All Rights Reserved                                                   *
*                                                                           *
\***************************************************************************/

#ifndef         EXEC_TYPES_H
#include        <exec/types.h>
#endif
#ifndef         EGS_EGSINTUI_H
#include        <egs/egsintui.h>
#endif
#ifndef         EGS_EGSGADBOX_H
#include        <egs/egsgadbox.h>
#endif
#ifndef         EGS_EGB_GBSCROLLBOX_H
#include        <egs/egb/gbscrollbox.h>
#endif

#define ER_USER_GADID_MIN  0x100000
#define ER_USER_GADID_MAX  0x1FFFFF

#define ER_REQ_OK         0
#define ER_REQ_FINISHED   1
#define ER_NO_REQWINDOW   2
#define ER_REQ_CANCELED   3

#define ER_AUTO_CLOSE     1


typedef struct ER_ReqContext *ER_ReqContextPtr;
typedef struct ER_Request *ER_RequestPtr;

struct ER_ReqContext{
          ER_RequestPtr        First,Last;
};


struct ER_Request{
         APTR                 ObjectKey;
         LONG                 Type;
         ER_ReqContextPtr     Context;
         ER_RequestPtr        Next,Prev;
         UBYTE                Error;
         UBYTE                Pad1;
         UWORD                Pad2;
         APTR                 UserData;
         LONG                 TriMics;
         LONG                 TriSecs;
         LONG                 OldMics;
         LONG                 OldSecs;
         LONG                 NewMics;
         LONG                 NewSecs;
         char                *Title;
         EI_NewWindowPtr      Nw;
         EB_GadContext        Con;
         EB_GadBoxPtr         Root;
         EI_MenuPtr           Menu;
         APTR                 reserved;
         struct MsgPort      *Port;
         EI_ScreenPtr         Screen;
         EI_WindowPtr         RWindow;
         LONG                 Flags;
         APTR                 Build;
         APTR                 Refresh;
         APTR                 Handle;
         APTR                 AddMenu;
         APTR                 FindGadgets;
         APTR                 SaveGadgets;
         APTR                 RestGadgets;
         APTR                 InitGadgets;
};

struct ER_TextList{
         struct List          List;
         UWORD                Pad;
         APTR                 Con;
};


struct ER_FileRequest {
         struct ER_Request    Req;
         UWORD                NameLen;
         char                 Name[32];
         UWORD                Pad0;
         UWORD                PathLen;
         char                 Path[100];
         UWORD                Pad1;
         UWORD                PattLen;
         char                 Pattern[100];
         UWORD                Pad2;
         struct EB_InfoBox    Fnumbox,Dnumbox;
         struct ER_TextList   Files,Volumes;
         EGB_ScrollGadPtr     FileGad,VolGad;
         EI_StringGadPtr      PathGad,NameGad,PattGad;
         UWORD                ONameLen;
         char                 OName[32];
         UWORD                Pad3;
         UWORD                OPathLen;
         char                 OPath[100];
         UWORD                Pad4;
         UWORD                OPattLen;
         char                 OPattern[100];
         UWORD                Pad5;
         struct Node         *OldFile;
         UBYTE                CursLeft;
         UBYTE                Pad6;
         UWORD                Pad7;
         struct Node         *LeftCurs,*RightCurs;
};

typedef struct ER_FileRequest *ER_FileRequestPtr;

struct   ER_ScrModeRequest {
                     struct ER_Request Req;
                     APTR              Reserved1;
                     APTR              Reserved2;
                     char              *ScreenMode;
                     WORD              Width;
                     WORD              Height;
                     LONG              Depths;
                     WORD              Depth;
                     WORD              Pad0;
};

typedef struct  ER_ScrModeRequest *ER_ScrModeReqPtr;

#define ER_sALL              0x00000001
#define ER_sROMFONT          0x00000002
#define ER_sDISKFONT         0x00000004
#define ER_sNONPROPORTIONAL  0x00000008
#define ER_sPROPORTIONAL     0x00000010
#define ER_sFONTSTYLES       0x00000020
#define ER_sDISPLAYIMMEDIATE 0x00000040
#define ER_sLAST             0x00000080


struct ER_FontRequest {
                     struct ER_Request    Req;
                     APTR                 Reserved1;
                     APTR                 Reserved2;
                     WORD                 ExtReqFlags;
                     WORD                 Pad0;
                     struct TextAttr      Font;
};
typedef struct  ER_FontRequest *ER_FontReqPtr;


struct ER_SimpleRequest {
                     struct ER_Request    Req;
                     APTR                 Texts;
                     APTR                 Selects;
                     WORD                 Selected;
                     WORD                 Pad0;
};

typedef struct ER_SimpleRequest *ER_SimpleReqPtr;


#endif  /* EGS_EGSREQUEST_H */

