/*
 * load.rexx
 *
 * by A. Pratsch
 *
 * this ARexx script is freely distributable
 *
 * Script to automatically startup dia (if this is not allready done)
 * and load a picture.
 *
 * useful for directory opus (install as AmigaDOS-Command
 * "rx load.rexx")
 *
 * !!! set DIApath to the correct path of the DIA program !!!
 */

PARSE ARG name

OPTIONS RESULTS

DIApath = 'WORK:Piccolo/DIA/DIA "SCREEN=PICOa:EGS 640x480" DEPTH=24 ZOOM=ON AUTOCLEAR=ON';

LibName = 'rexxsupport.library'
Max_Seconds_To_Load = 60
Flag = 0

IF POS( LibName, SHOW( 'Libraries' ) ) = 0 THEN	ADDLIB( LibName, 0, -30, 0 )
IF POS( LibName, SHOW( 'Libraries' ) ) = 0 THEN	EXIT

TIME( 'R' )
DO WHILE (TIME( 'E' ) < Max_Seconds_To_Load) & (POS( 'rainbow', SHOW( 'Ports' ) ) = 0)
	IF Flag = 0 THEN DO
		/* Set whatever command line arguments you want. */
		ADDRESS COMMAND 'run <nil: >nil: ' || DIApath;
		Flag = 1
	END
	ADDRESS COMMAND 'WAIT 1'
END

IF POS( 'rainbow', SHOW( 'Ports' ) ) = 0 THEN
DO
	SAY "Failed!"
	EXIT
END
ELSE DO
	path=PRAGMA('D','')
	/* check if path is given, otherwise add current path to name
	 */
	if ~ ((VERIFY('/',name)==0) | (VERIFY(':',name)==0)) THEN DO
	   name=path || '/' || name
	END

	IF EXISTS(name) THEN DO 			/* existiert File ? */
		address "rainbow";

		SAY "loading " || name || "..."
		AUTOCLEAR ON
		OPEN name							/* wenn ja, Bild laden */
	END
	ELSE DO
		say name || " doesn't exist."
	END
END

